%if 0%{?with_debug}
# https://bugzilla.redhat.com/show_bug.cgi?id=995136#c12
%global _dwz_low_mem_die_limit 0
%else
%global debug_package   %{nil}
%endif

%global build_dir           src/github.com/coredns/coredns

# coredns release version major.minor
%global coredns_major_version 1
%global coredns_minor_version 3
%global coredns_patch_version 1
#%global system_name		coredns

Name:           coredns
Version:        %{coredns_major_version}.%{coredns_minor_version}.%{coredns_patch_version}
Release:        1.0.4%{?dist}
BuildArch:      x86_64
Summary:        DNS and Service Discovery
License:        Apache-2.0
Group:          System/Management
Url:            https://github.com/coredns/coredns
Source:         %{name}-%{version}.tar.bz2
Vendor:         Oracle America
BuildRequires:  golang = 1.12.10
%description
CoreDNS is a DNS server.
It can be used in a multitude of environments because of its flexibility.
CoreDNS chains plugins. Each plugin performs a DNS function, such as
Kubernetes service discovery, Prometheus metrics or rewriting queries.
And many more.

%prep
%setup -q -n coredns-%{version}
mkdir -p %{build_dir}
mv $(ls | grep -v "^src$") %{build_dir}
mv .presubmit %{build_dir}

%build
export GOPATH=$(pwd)
pushd %{build_dir}

# NOTE: REMOVE THIS IN NEWER RELEASES. We are chaging how
# caddy is being installed since one of its dependencies requires
# golang >= 1.13 at master and we are not building with golang@1.13. We
# fix this by only downloading the package by passing `-d` to `go get`.
# NOTE: This is a copy from the makefile godeps section setting `-d` on the caddy install

(cd $GOPATH/src/github.com/mholt/caddy 2>/dev/null              && git checkout -q master 2>/dev/null || true)
(cd $GOPATH/src/github.com/miekg/dns 2>/dev/null                && git checkout -q master 2>/dev/null || true)
(cd $GOPATH/src/github.com/prometheus/client_golang 2>/dev/null && git checkout -q master 2>/dev/null || true)
go get -d -u github.com/mholt/caddy
go get -u github.com/miekg/dns
go get -u github.com/prometheus/client_golang/prometheus/promhttp
go get -u github.com/prometheus/client_golang/prometheus
(cd $GOPATH/src/github.com/mholt/caddy              && git checkout -q v0.11.1)
(cd $GOPATH/src/github.com/miekg/dns                && git checkout -q v1.1.3)
(cd $GOPATH/src/github.com/prometheus/client_golang && git checkout -q v0.9.1)

# NOTE: By setting 'CHECKS=' we are disabling the 'check' and 'godeps' in makefile
# to work around issue described above
make CHECKS= presubmit core/plugin/zplugin.go core/dnsserver/zdirectives.go coredns

popd

%install
install -D -p -m 0755 %{build_dir}/coredns %{buildroot}%{_bindir}/%{name}
mv %{build_dir}/LICENSE .
mv %{build_dir}/THIRD_PARTY_LICENSES.txt .

%files
%license LICENSE THIRD_PARTY_LICENSES.txt
%{_bindir}/%{name}

%changelog
* Thu Oct 17 2019 Tom Cocozzello <tom.cocozzello@oracle.com> - 1.3.1-1.0.4
- [CVE-2019-16276] bump golang to 1.12.10
- Simplify container image build to allow the rpm db to contain coredns
* Thu Oct 17 2019 Tom Cocozzello <tom.cocozzello@oracle.com> 1.3.1-1.0.3
- Added THIRD_PARTY_LICENSES.txt
* Tue Oct 08 2019 Tom Cocozzello <tom.cocozzello@oracle.com> - 1.3.1-1.0.2
- Fix build issue with go get
* Mon Jun 24 2019 Thomas Tanaka <thomas.tanaka@oracle.com> - 1.3.1-1.0.1
- Update to 1.3.1
